﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Color_3
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            //도형을 선택했을때 색이 변하는 이밴트 생성
            back.MouseLeftButtonDown += new MouseButtonEventHandler(myRect_MouseLeftButtonDown);
            star1.MouseLeftButtonDown += new MouseButtonEventHandler(star1_MouseLeftButtonDown);
            star2.MouseLeftButtonDown += new MouseButtonEventHandler(star2_MouseLeftButtonDown);
            star3.MouseLeftButtonDown += new MouseButtonEventHandler(star3_MouseLeftButtonDown);
            star4.MouseLeftButtonDown += new MouseButtonEventHandler(star4_MouseLeftButtonDown);
    
            //각 슬라이드의 값이 변할 경우 이벤트 설정
            rSlide.ValueChanged += new RoutedPropertyChangedEventHandler<double>(rSlide_ValueChanged);
            gSlide.ValueChanged += new RoutedPropertyChangedEventHandler<double>(gSlide_ValueChanged);
            bSlide.ValueChanged += new RoutedPropertyChangedEventHandler<double>(bSlide_ValueChanged);
        }

        void star4_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //선택된 도형의 색을 바꿔주기 위한 이벤트 핸들러
            //getColorBrush()함수를 이용해서 Slide가 만든 색으로 SolidColorBrush를 만들어서 받는다.
            star4.Fill = getColorBrush();
        }

        void star3_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            star3.Fill = getColorBrush();
        }

        void star2_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            star2.Fill = getColorBrush();
        }

        void star1_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            star1.Fill = getColorBrush();
        }


        void bSlide_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            //slide의 값이 변한 이벤트에대한 핸들러로 setColor()함수를 호출해준다.
            setColor();
        }

        void gSlide_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            setColor();
        }

        void rSlide_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            setColor();
        }

        void myRect_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            back.Fill = getColorBrush();
        }

        private SolidColorBrush getColorBrush()
        {
            //슬라이더에 RGB로 표현되는 색을 SolidColorBrush로 생성해서 반환.
            byte r, g, b;
            r = (byte)rSlide.Value;
            g = (byte)gSlide.Value;
            b = (byte)bSlide.Value;
            //Color.FromArgb의 인자들은 byte형으로 받기때문에 byte로 저장

            return new SolidColorBrush(Color.FromArgb(255, r, g, b));
        }

       

        private void setColor()
        {
            //각 슬라이드의 값을 받아서 상자의 색을 바꾸어주는 함수
            byte r, g, b;
            r = (byte)rSlide.Value;
            g = (byte)gSlide.Value;
            b = (byte)bSlide.Value;
            //Color.FromArgb의 인자들은 byte형으로 받기때문에 byte로 저장

            myRect.Fill = new SolidColorBrush(Color.FromArgb(255, r, g, b));
        }


    }
}
