﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace color_5
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
        }

        private void setBox()
        {
            int i, j;
            Random rb = new Random();
            for (i = 0; i < 20; i++)
            {
                for (j = 0; j < 15; j++)
                {
                    Rectangle tmp = new Rectangle();
                    tmp.SetValue(Canvas.LeftProperty, (double)(20 * i + 10));
                    tmp.SetValue(Canvas.TopProperty, (double)(20 * j + 10));

                    //tmp.Fill = new SolidColorBrush(Color.FromArgb((byte)255, (byte)rb.Next(0, 255), (byte)255, (byte)255));
                    tmp.Fill = new SolidColorBrush(ColorFromAhsb((byte)255, (float)rb.Next(0, 360), (float)1, (float)0.5));

                    tmp.Width = 20;
                    tmp.Height = 20;
                    LayoutRoot.Children.Add(tmp);
                }
            }
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            setBox(); //시작될때 box를 나열하는 함수를 호출
        }
        
        //아래는 RGB를 HSB로 변환하는 알고리즘입니다.(교장선생님이 찾아주셨어요^^;;)
        public Color ColorFromAhsb(byte a, float h, float s, float b)
        {
            if (0 == s)
            {
                return Color.FromArgb(a, (byte)(b * 255), (byte)(b * 255), (byte)(b * 255));
            }
            float fMax, fMid, fMin;
            int iSextant;
            byte iMax, iMid, iMin;
            
            if (0.5 < b)
            {
                fMax = b - (b * s) + s;
                fMin = b + (b * s) - s;
            }
            else
            {
                fMax = b + (b * s);
                fMin = b - (b * s);
            }
            iSextant = (int)Math.Floor(h / 60f);
            if (300f <= h)
            {
                h -= 360f;
            }
            h /= 60f;
            h -= 2f * (float)Math.Floor(((iSextant + 1f) % 6f) / 2f);
            if (0 == iSextant % 2)
            {
                fMid = h * (fMax - fMin) + fMin;
            }
            else
            {
                fMid = fMin - h * (fMax - fMin);
            }
            iMax = (byte)(fMax * 255);
            iMid = (byte)(fMid * 255);
            iMin = (byte)(fMin * 255);
            switch (iSextant)
            {
                case 1:
                    return Color.FromArgb(a, iMid, iMax, iMin);
                case 2:
                    return Color.FromArgb(a, iMin, iMax, iMid);
                case 3:
                    return Color.FromArgb(a, iMin, iMid, iMax);
                case 4:
                    return Color.FromArgb(a, iMid, iMin, iMax);
                case 5:
                    return Color.FromArgb(a, iMax, iMin, iMid);
                default:
                    return Color.FromArgb(a, iMax, iMid, iMin);
            }
        }
    }
}
